SystemOrganization addCategory: #'Graphic-Text-SystemSettings'!

Object subclass: #StandardFontsSystemSettings
	instanceVariableNames: ''
	classVariableNames: 'ButtonFont'
	poolDictionaries: ''
	category: 'Graphic-Text-SystemSettings'!

!StandardFontsSystemSettings classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/3/2009 09:34'!
resetAllFontToDefault
	#( #codeFont:  #listFont: #menuFont: #buttonFont: #windowTitleFont: #balloonFont: #haloFont:) 
		do: [:selector | StandardFonts perform: selector with: StandardFonts defaultFont].
	SettingBrowser refreshAllSettingBrowsers
	 
! !

!StandardFontsSystemSettings classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/2/2009 13:56'!
resetAllFontToDefaultButton
			^ (UITheme current
				newButtonIn: World 
				for: self
				getState: nil
				action: #resetAllFontToDefault
				arguments: {}
				getEnabled: nil
				getLabel: nil
				help: 'Set all predefined system fonts to the default one')
		 		label: (UITheme current newRowIn: World for: {AlphaImageMorph new image: MenuIcons smallRedoIcon. UITheme current buttonLabelForText: 'Reset all to default'});
		 		yourself.
! !

!StandardFontsSystemSettings classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/2/2009 13:57'!
standardFontsOn: aBuilder
	<systemsettings>
	(aBuilder group: #standardFonts)
		label: 'Standard fonts' translated;
		parent: #appearance;
		dialog: (MessageSend receiver: self selector: #updateFromSystemButton);
		noOrdering;
		with: [
			(aBuilder setting: #defaultFont)
				target: StandardFonts;
				description: 'The default text font';
				dialog: (MessageSend receiver: self selector: #resetAllFontToDefaultButton);
				label: 'Default'.
			(aBuilder setting: #codeFont)
				target: StandardFonts;
				description: 'The standard code font';
				label: 'Code'.
			(aBuilder setting: #listFont)
				target: StandardFonts;
				description: 'The standard list font';
				label: 'List'.
			(aBuilder setting: #menuFont)
				target: StandardFonts;
				description: 'The standard menu font';
				label: 'Menu'.
			(aBuilder setting: #buttonFont)
				target: StandardFonts;
				description: 'The standard button font';
				label: 'Button'.
			(aBuilder setting: #windowTitleFont)
				target: StandardFonts;
				description: 'The standard window title font';
				label: 'Window title'.
			(aBuilder setting: #balloonFont)
				target: StandardFonts;
				description: 'The standard balloon-help font';
				label: 'Balloon-help'.
			(aBuilder setting: #haloFont)
				target: StandardFonts;
				description: 'The morphic halo font';
				label: 'Morphic halo']
				
				! !

!StandardFontsSystemSettings classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 12/2/2009 13:55'!
updateFromSystemButton
	^ (UITheme current
				newButtonIn: World 
				for: FreeTypeFontProvider current
				getState: nil
				action: #updateFromSystem
				arguments: {}
				getEnabled: nil
				getLabel: nil
				help: 'Update available fonts by scaning the current system')
		 		label: (UITheme current newRowIn: World for: {AlphaImageMorph new image: MenuIcons smallRedoIcon. UITheme current buttonLabelForText: 'Update fonts from system'});
		 		yourself.! !
